#include <bits/stdc++.h>

using namespace std;
using ll = long long;

vector<vector<int> > g;

void solve() {
    int n, m, k;
    cin >> n >> m >> k;
    g.resize(n + 1);
    for (int i = 0; i < m; i++) {
        int a, b;
        cin >> a >> b;
        g[a].push_back(b);
        g[b].push_back(a);
    }
    vector<int> dist(n + 1, -1);
    set<pair<int, int> > s;
    for (int i = 0; i < k; i++) {
        int a, b;
        cin >> a >> b;
        dist[a] = b;
        s.insert({dist[a], a});
    }
    vector<int> ans(n + 1);
    while (!s.empty()) {
        pair<int, int> i = *s.rbegin();
        int d = i.first;
        int v = i.second;
        s.erase(i);
        ans[v] = 1;
        if (dist[v] > 0) {
            for (auto it: g[v]) {
                if (d - 1 > dist[it]) {
                    s.erase({dist[it], it});
                    dist[it] = d - 1;
                    s.insert({dist[it], it});
                }
            }
        }
    }
    vector<int> q;
    int cnt = 0;
    for (int i = 1; i <= n; i++) {
        if (ans[i] == 1) {
            cnt++;
            q.push_back(i);
        }
    }
    cout << cnt << "\n";
    for (auto it: q) {
        cout << it << " ";
    }
}

int main() {
    // freopen("input.txt", "r", stdin);
    // freopen("output.txt", "w", stdout);
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    solve();
    return 0;
}
