#include <bits/stdc++.h>

using namespace std;
using ll = long long;

void solve() {
    int n;
    cin >> n;
    vector<pair<int, int> > m(n + 1);
    for (int i = 0; i < n; i++) {
        int a, b;
        cin >> a >> b;
        m[i + 1] = {a, b};
    }
    long double a = 3 * sqrt(2);
    vector<int> vis(n + 1);
    set<pair<long double, int> > s;
    long double ans = 0;
    vector<long double> dist(n + 1, 1e9);
    dist[1] = 0;
    s = {{0, 1}};
    while (!s.empty()) {
        pair<long double, int> r = *s.begin();
        int v = r.second;
        long double w = r.first;
        ans += w;
        s.erase(s.begin());
        vis[v] = 1;
        for (int i = 1; i <= n; i++) {
            if (vis[i] == 0) {
                long double d = (double) (sqrt(
                    (m[v].first - m[i].first) * (m[v].first - m[i].first) + (m[v].second - m[i].second) * (
                        m[v].second - m[i].second)));
                if (dist[i] > d) {
                    s.erase({dist[i], i});
                    dist[i] = d;
                    s.insert({dist[i], i});
                }
            }
        }
    }
    cout << ans;
}

int main() {
    // freopen("input.txt", "r", stdin);
    // freopen("output.txt", "w", stdout);
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    solve();
    return 0;
}
